﻿using System;
using System.Collections;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.IO;

namespace RinGOch.HtmlGenerators
{
	public class TwoChGenerator
	{
		public static string GenerateMenu()
		{
			StringBuilder xml = new StringBuilder();
			StringWriter writer = new StringWriter(xml);

			WebClient wc = new WebClient();
			string temp = Encoding.GetEncoding("shift-jis").GetString(wc.DownloadData("http://www.ff.iij4u.or.jp/~ch2/bbsmenu.html"));
			int pos1 = temp.ToLower().IndexOf("<font size=2>");if(pos1 < 0)pos1 = 0;
			int pos2 = temp.ToLower().LastIndexOf("<br>");;if(pos1 < 0)pos2 = temp.Length;
			temp = temp.Substring(pos1,pos2-pos1);
			writer.Write(temp);

			writer.WriteLine("<BR><BR><B>RinGOch</B><BR>");
			writer.WriteLine(string.Concat("<A HREF=",
				HttpHtmlGenerator.CreateLocalAddress(),HttpUtility.UrlEncode("すべて"),"/>",HttpUtility.HtmlEncode("すべて"),"</A><br>"));
			foreach(string cate in WebCategories.Categories)
			{
				writer.WriteLine(string.Concat("<A HREF=",
					HttpHtmlGenerator.CreateLocalAddress(),HttpUtility.UrlEncode(cate),"/>",HttpUtility.HtmlEncode(cate),"</A><br>"));
			}

			writer.Close();
			return xml.ToString();
		}

		public static string GenerateSubject(string cate)
		{
			StringBuilder xml = new StringBuilder();
			StringWriter writer = new StringWriter(xml);

			cate = cate.ToLower();
			object[] threads = Interface.GetWebHeaders();
			Array.Sort(threads,new WebHeaderComparer(WebHeaderComparerField.Update,true));

			foreach(WebHeaderInfo info in threads)
			{
				if( (info.Category.ToLower() == cate || cate == "すべて") && (info.Type==WebType.FileBoard || info.Type == WebType.ImageBoard || info.Type == WebType.TextOnlyBoard))
				{
					if(HttpServerSetting.UseExtendedDat)
					{
						writer.WriteLine(string.Concat(info.GUID.ToString(),".cgi<>",HttpUtility.HtmlEncode(info.Title)," (",info.Posts.ToString(),")"));
					}
					else
						writer.WriteLine(string.Concat(info.GUID.ToString(),".dat<>",HttpUtility.HtmlEncode(info.Title)," (",info.Posts.ToString(),")"));
				}
			}

			writer.Close();
			return xml.ToString();
		}

		public static string GenerateDat(Guid id)
		{
			if(WebCacheReader.IsCached(id))
			{
				WebHeaderInfo info = WebCacheReader.ReadHeader(id);

				if(!(info.Type==WebType.FileBoard || info.Type == WebType.ImageBoard || info.Type == WebType.TextOnlyBoard))
					return "";

				WebPostInfo[] posts = WebCacheReader.ReadAllPost(info.GUID);
				StringBuilder xml = new StringBuilder();
				StringWriter writer = new StringWriter(xml);

				ArrayList errors = new ArrayList(WebCertificationCache.GetSignErrorList(info.GUID));
				int noSignCheck = Array.IndexOf(posts,new WebPostInfo("","",DateTime.Now,WebCertificationCache.GetEndGuid(info.GUID,info.Created),null,null,"",null));
				int index = 0;

				foreach(WebPostInfo post in posts)
				{
					string body = HttpUtility.HtmlEncode(post.Body).Replace("\r\n","\n").Replace("\r","\n").Replace("\n","<BR>");
					body = HttpHtmlGenerator.ReplaceLocalAddress(body);
					if(post.Data != null && post.Data.Length > 0)
					{
						body += "<BR><BR>" + HttpHtmlGenerator.CreateURLLink(string.Concat(HttpHtmlGenerator.CreateLocalAddress(),info.GUID.ToString(),"/",post.GUID.ToString(),"/",HttpUtility.UrlEncode(post.FileName)));
					}
					string name = post.Name;
					if(post.Trip != null)
					{
						if(index > noSignCheck)
						{
							if(!post.IsEffectiveSignature())
							{
								name += "◆認証エラー";
								errors.Add(post.GUID);
							}
							else
								name += "◆" + TextUtility.XmlToTrip(Encoding.ASCII.GetString(post.Trip));
						}
						else
							name += "◆" + TextUtility.XmlToTrip(Encoding.ASCII.GetString(post.Trip));
					}
					writer.WriteLine(string.Concat(
						HttpUtility.HtmlEncode(name),
						"<><>",
						HttpUtility.HtmlEncode(post.Posted.ToString()),
						"<>",
						body,
						"<>"));
					index++;
				}

				WebCertificationCache.SetEndGuid(info.GUID,info.Created,posts[posts.Length-1].GUID,(Guid[])errors.ToArray(typeof(Guid)));

				writer.Close();
				return xml.ToString();
			}
			else
			{
				Interface.CheckUpdatePage(id);
				return "";
			}
		}

		public static string GenerateJBBSDat(Guid id)
		{
			if(WebCacheReader.IsCached(id))
			{
				WebHeaderInfo info = WebCacheReader.ReadHeader(id);

				if(!(info.Type==WebType.FileBoard || info.Type == WebType.ImageBoard || info.Type == WebType.TextOnlyBoard))
					return "";

				WebPostInfo[] posts = WebCacheReader.ReadAllPost(info.GUID);
				StringBuilder xml = new StringBuilder();
				StringWriter writer = new StringWriter(xml);

				ArrayList errors = new ArrayList(WebCertificationCache.GetSignErrorList(info.GUID));
				int noSignCheck = Array.IndexOf(posts,new WebPostInfo("","",DateTime.Now,WebCertificationCache.GetEndGuid(info.GUID,info.Created),null,null,"",null));
				int index = 0;

				foreach(WebPostInfo post in posts)
				{
					string body = HttpUtility.HtmlEncode(post.Body).Replace("\r\n","\n").Replace("\r","\n").Replace("\n","<BR>");
					body = HttpHtmlGenerator.ReplaceLocalAddress(body);
					if(post.Data != null && post.Data.Length > 0)
					{
						body += "<BR><BR>" + HttpHtmlGenerator.CreateURLLink(string.Concat(HttpHtmlGenerator.CreateLocalAddress(),info.GUID.ToString(),"/",post.GUID.ToString(),"/",HttpUtility.UrlEncode(post.FileName)));
					}
					string name = post.Name;
					if(post.Trip != null)
					{
						if(index > noSignCheck)
						{
							if(!post.IsEffectiveSignature())
							{
								name += "◆認証エラー";
								errors.Add(post.GUID);
							}
							else
								name += "◆" + TextUtility.XmlToTrip(Encoding.ASCII.GetString(post.Trip));
						}
						else
							name += "◆" + TextUtility.XmlToTrip(Encoding.ASCII.GetString(post.Trip));
					}

					if(index == 0)
					{
						writer.WriteLine(string.Concat(
							TextUtility.GuidToResID(post.GUID),
							"<>",
							HttpUtility.HtmlEncode(name),
							"<><>",
							HttpUtility.HtmlEncode(post.Posted.ToString()),
							"<>",
							body,
							"<>",
							HttpUtility.HtmlEncode(info.Title),
							"<>"
							));
					}
					else
					{
						writer.WriteLine(string.Concat(
							TextUtility.GuidToResID(post.GUID),
							"<>",
							HttpUtility.HtmlEncode(name),
							"<><>",
							HttpUtility.HtmlEncode(post.Posted.ToString()),
							"<>",
							body,
							"<><>"));
					}
					index++;
				}

				WebCertificationCache.SetEndGuid(info.GUID,info.Created,posts[posts.Length-1].GUID,(Guid[])errors.ToArray(typeof(Guid)));

				writer.Close();
				return xml.ToString();
			}
			else
			{
				Interface.CheckUpdatePage(id);
				return "";
			}
		}
	}
}
