﻿using System;
using System.IO;
using System.Collections;
using System.Collections.Specialized;
using System.Text;
using System.Text.RegularExpressions;

namespace RinGOch
{
	/// <summary>
	/// HttpPostDataProcessor の概要の説明です。
	/// </summary>
	public class HttpPostDataProcessor
	{
		public static byte[] Process(StringDictionary param)
		{
			if(param[""].StartsWith("manage.p2p"))
				return PostProcessors.ManagementProcessor.Process(param);
			else if(param["_path"] == "/test/bbs.cgi")
				return PostProcessors.TwoChPostProcessor.Process(param);
			else if(param[""].StartsWith("trip.p2p"))
				return PostProcessors.TripGenerateProcessor.Process(param);
			else if(param[""].StartsWith("chat.p2p"))
				return PostProcessors.ChatProcessor.Process(param);
			else if(param[""].StartsWith("ignore.p2p"))
				return PostProcessors.ManagementProcessor.ProcessIgnore(param);
			else if(param[""].StartsWith("delete.p2p"))
				return PostProcessors.ManagementProcessor.ProcessDelete(param);
			else if(param[""].StartsWith("blogmgr.p2p"))
				return HtmlGenerators.BlogEngine.ProcessManage(param);
			else if(param[""].StartsWith("cachetools.p2p"))
			{
				string test = "text/html";
				return HtmlGenerators.MenuGenerator.Generate(param,ref test);
			}
			else
				return PostProcessors.PageCreateProcessor.Process(param);
		}
		public static byte[] Process(Guid id,StringDictionary param)
		{
			WebHeaderInfo info = WebCacheReader.ReadHeader(id);
			switch(info.Type)
			{
				case WebType.FileBoard:
				case WebType.ImageBoard:
				case WebType.TextOnlyBoard:
					if(param["_filename"] == "abon.p2p")
						return PostProcessors.BbsProcessor.ProcessResAbon(info,param);
					else
						return PostProcessors.BbsProcessor.Process(info,param);
				case WebType.Wiki:
					return PostProcessors.WikiProcessor.Process(info,param);
				case WebType.Blog:
					return HtmlGenerators.BlogEngine.Process(info,param);
				default:
					return null;
			}
		}
	}
}
