﻿using System;

namespace RinGOch
{
	/// <summary>
	/// HttpServerの各種設定
	/// </summary>
	public class HttpServerSetting
	{
		#region ログ取りモード
		static bool _logging = false;
		public static bool LoggingMode
		{
			get { return _logging; }
			set { _logging = value;}
		}
		#endregion

		#region コネクション制限
		static int _max = 256;
		public static int NumberOfMaximumConnections
		{
			get { return _max; }
			set { _max = value;}
		}
		#endregion

		#region 外部からの接続
		static bool _remote = false;
		public static bool AcceptRemote
		{
			get { return _remote; }
			set { _remote = value;}
		}
		#endregion

		#region 公開モードかどうか
		static bool _public = false;
		public static bool PublicMode
		{
			get { return _public; }
			set { _public = value;}
		}
		#endregion

		#region サーバポート
		static int _port = 8000;
		public static int ServerPort
		{
			get { return _port; }
			set { _port = value;}
		}
		#endregion

		#region バインドアドレス
		static string _local = "";
		public static string BindAddress
		{
			get { return _local; }
			set { _local = value;}
		}
		#endregion

		#region 出力Encoding
		static System.Text.Encoding _encoding = System.Text.Encoding.UTF8;
		public static System.Text.Encoding HtmlEncoding
		{
			get { return _encoding; }
			set { _encoding = value;}
		}
		#endregion

		#region サムネイル
		static int _thumWidth = 160;
		static int _thumHeight = 160;
		static System.Drawing.Drawing2D.InterpolationMode _thumQuality = System.Drawing.Drawing2D.InterpolationMode.HighQualityBicubic;
		public static int ThumbnailWidth
		{
			get { return _thumWidth; }
			set { _thumWidth = value;}
		}
		public static int ThumbnailHeight
		{
			get { return _thumHeight; }
			set { _thumHeight = value;}
		}
		public static System.Drawing.Drawing2D.InterpolationMode ThumbnailInterpolationMode
		{
			get { return _thumQuality; }
			set { _thumQuality = value;}
		}
		#endregion

		#region ログ出力パス
		static string _logpath = "C:\\";
		public static string LogFilePath
		{
			get { return _logpath; }
			set { _logpath = value;}
		}
		#endregion

		#region 圧縮
		static bool _useGzip = false;
		public static bool UseGzipDeflate
		{
			get { return _useGzip; }
			set { _useGzip = value;}
		}
		#endregion

		#region BBSParameter
		static string _bbsParam;
		public static string BBSParameter
		{
			get { return _bbsParam; }
			set { _bbsParam = value;}
		}
		#endregion

		#region パスワード
		static string _pass;
		public static string BasicPassword
		{
			get { return _pass; }
			set { _pass = value;}
		}
		#endregion

		#region ローカルからも認証
		static bool _localAuth = false;
		public static bool AuthorizeLocalAccess
		{
			get { return _localAuth; }
			set { _localAuth = value;}
		}
		#endregion

		#region 常に認証
		static bool _alwaysAuth = false;
		public static bool AlwaysAuthorize
		{
			get { return _alwaysAuth; }
			set { _alwaysAuth = value;}
		}
		#endregion

		#region Datの形式を拡張形式にする
		static bool _useExtendedDat = false;
		public static bool UseExtendedDat
		{
			get { return _useExtendedDat; }
			set { _useExtendedDat = value;}
		}
		#endregion
	
		#region メモリ関係
		static bool _a10;
		static bool _a11;
		public static bool MemoryCleansUpPeriodically
		{
			get { return _a10;}
			set { _a10 = value;}
		}
		public static bool LoggingMemory
		{
			get { return _a11;}
			set { _a11 = value;}
		}
		#endregion
	}
}
