using System;
using System.Collections;
using System.IO;
using System.Collections.Specialized;

namespace RinGOch.PostProcessors
{
	public class BbsProcessor
	{
		public static byte[] Process(WebHeaderInfo info,StringDictionary param)
		{
			string temp = HttpHtmlGenerator.ReadTemplateFile("template\\bbs\\post.html");
			bool error = false;
			byte[] binary = null;
			if(param["name"] == "")param["name"] = "名無し";

			try
			{
				binary = Convert.FromBase64String((param["binary"]==null?param["binary64"]:param["binary"]));
				if(binary!=null && binary.Length > 0)
				{
					if(info.Type == WebType.ImageBoard)
					{
						try
						{
							using(MemoryStream ms = new MemoryStream(binary))
							{
								using(System.Drawing.Bitmap bmp = new System.Drawing.Bitmap(ms))
								{
									if(bmp.Width <= 0 || bmp.Height <= 0)
										throw new Exception();
								}
							}
						}
						catch
						{
							error = true;
							binary = null;
						}
					}
				}
				else
				{
					binary = null;
				}
			}
			catch
			{
				binary = null;
			}

			if(param["message"].Length == 0 || (binary!=null && binary.Length > 1024*1024*1))
				error = true;

			if(error)
			{
				temp = temp.Replace("%NAME%",(string)param["name"])
					.Replace("%TRIP%",(string)param["trip"])
					.Replace("%BODYBR%",HttpUtility.HtmlEncode(param["message"]).Replace("\r\n","\n").Replace("\r","\n").Replace("\n","<BR>"))
					.Replace("%BODY%",HttpUtility.HtmlEncode(param["message"]))
					.Replace("%STYLE%",HttpHtmlGenerator.ReadStyleSheet("template\\bbs\\"))
					.Replace("%CHECK%","")
					.Replace("%BINARY%","")
					.Replace("%RESULT%","エラー");
				string header = TextUtility.GetMiddleRangeString(temp,"<!--BEGIN HEADER-->","<!--END HEADER-->");
				string footer = TextUtility.GetMiddleRangeString(temp,"<!--BEGIN FOOTER-->","<!--END FOOTER-->");
				return System.Text.Encoding.UTF8.GetBytes(header + TextUtility.GetMiddleRangeString(temp,"<!--BEGIN FAILURE-->","<!--END FAILURE-->") + footer);
			}
			else
			{
				if(param.ContainsKey("check") && (string)param["check"].ToLower() == "passed")
				{
					if(Interface.CanPost())
					{
						temp = temp.Replace("%NAME%",(string)param["name"])
							.Replace("%TRIP%",(string)param["trip"])
							.Replace("%BODYBR%",HttpUtility.HtmlEncode(param["message"]).Replace("\r\n","\n").Replace("\r","\n").Replace("\n","<BR>"))
							.Replace("%BODY%",HttpUtility.HtmlEncode(param["message"]))
							.Replace("%STYLE%",HttpHtmlGenerator.ReadStyleSheet("template\\bbs\\"))
							.Replace("%CHECK%","")
							.Replace("%BINARY%","")
							.Replace("%FILENAME%","")
							.Replace("%RESULT%","投稿に成功しました");

						string fname = "";
						if(binary != null)
						{
							fname = Path.GetFileName(param["filename"]);
							if(fname == null)
								fname = "unknown";
						}

						Guid postGuid = Interface.PostToBbs(info.GUID,param["name"],param["message"],param["trip"],binary,fname);
						temp = temp.Replace("%SGUID%",TextUtility.GuidToResID(postGuid));
						string header = TextUtility.GetMiddleRangeString(temp,"<!--BEGIN HEADER-->","<!--END HEADER-->");
						string footer = TextUtility.GetMiddleRangeString(temp,"<!--BEGIN FOOTER-->","<!--END FOOTER-->");
						return System.Text.Encoding.UTF8.GetBytes(header + TextUtility.GetMiddleRangeString(temp,"<!--BEGIN SUCCESS-->","<!--END SUCCESS-->") + footer);
					}
					else
					{
						temp = temp.Replace("%NAME%",(string)param["name"])
							.Replace("%TRIP%",(string)param["trip"])
							.Replace("%BODYBR%",HttpUtility.HtmlEncode(param["message"]).Replace("\r\n","\n").Replace("\r","\n").Replace("\n","<BR>"))
							.Replace("%BODY%",HttpUtility.HtmlEncode(param["message"]))
							.Replace("%STYLE%",HttpHtmlGenerator.ReadStyleSheet("template\\bbs\\"))
							.Replace("%CHECK%","Passed")
							.Replace("%BINARY%",param["binary64"])
							.Replace("%FILENAME%",param["filename"])
							.Replace("%RESULT%","連投制限中");
						string header = TextUtility.GetMiddleRangeString(temp,"<!--BEGIN HEADER-->","<!--END HEADER-->");
						string footer = TextUtility.GetMiddleRangeString(temp,"<!--BEGIN FOOTER-->","<!--END FOOTER-->");
						return System.Text.Encoding.UTF8.GetBytes(header + TextUtility.GetMiddleRangeString(temp,"<!--BEGIN REGULATION-->","<!--END REGULATION-->") + footer);
					}
				}
				else
				{
					temp = temp.Replace("%NAME%",param["name"])
						.Replace("%TRIP%",param["trip"])
						.Replace("%BODYBR%",HttpUtility.HtmlEncode(param["message"]).Replace("\r\n","\n").Replace("\r","\n").Replace("\n","<BR>"))
						.Replace("%BODY%",HttpUtility.HtmlEncode(param["message"]))
						.Replace("%STYLE%",HttpHtmlGenerator.ReadStyleSheet("template\\bbs\\"))
						.Replace("%CHECK%","Passed")
						.Replace("%BINARY%",param["binary"])
						.Replace("%FILENAME%",param["filename"])
						.Replace("%RESULT%","内容の確認");
					string header = TextUtility.GetMiddleRangeString(temp,"<!--BEGIN HEADER-->","<!--END HEADER-->");
					string footer = TextUtility.GetMiddleRangeString(temp,"<!--BEGIN FOOTER-->","<!--END FOOTER-->");
					return System.Text.Encoding.UTF8.GetBytes(header + TextUtility.GetMiddleRangeString(temp,"<!--BEGIN CHECK-->","<!--END CHECK-->") + footer);
				}
			}
		}

		public static byte[] ProcessResAbon(WebHeaderInfo info,StringDictionary param)
		{
			if(HttpServer.HasAuthority(param))
			{
				string temp = HttpHtmlGenerator.ReadTemplateFile("template\\gateway\\basic.html");
				temp = HtmlGenerators.TemplateFieldReplacer.ReplaceField(temp,"%TITLE%","BBS管理マネージャ");
				try
				{
					string[] ls = param["guids"].Split(',');
					ArrayList list = new ArrayList(WebBbsAbon.GetList(info.GUID));
					foreach(string l in ls)
					{
						try
						{
							Guid id = new Guid(l);
								if(list.Contains(id)) {
										list.Remove(id);}
									else{
										list.Add(id);
									}
						}
						catch
						{
						}
					}

					WebBbsAbon.SetList(info.GUID,(Guid[])list.ToArray(typeof(Guid)));

					temp = HtmlGenerators.TemplateFieldReplacer.ReplaceField(temp,"%BODY%","あぼ～んリストを処理しました");
					return HttpServerSetting.HtmlEncoding.GetBytes(temp);
				}
				catch(Exception ex)
				{
					temp = HtmlGenerators.TemplateFieldReplacer.ReplaceField(temp,"%BODY%",ex.ToString());
					return HttpServerSetting.HtmlEncoding.GetBytes(temp);
				}
			}
			else
				throw HttpException.UnauthorizedException;
		}
	}
}
