﻿using System;
using System.Collections.Specialized;

namespace RinGOch.PostProcessors
{
	/// <summary>
	/// PageCreateProcessor の概要の説明です。
	/// </summary>
	public class PageCreateProcessor
	{
		/// <summary>
		/// スレ立て～
		/// </summary>
		public static byte[] Process(StringDictionary param)
		{
			if(!HttpServer.HasAuthority(param))
			{
				throw HttpException.UnauthorizedException;
			}
			else if(Interface.CanCreatePageB() && Interface.IsEffectiveCertificationKey(param["certi"]))
			{
				WebType type = WebType.TextOnlyBoard;
				switch(param["type"])
				{
					case "text":
						type = WebType.TextOnlyBoard;break;
					case "image":
						type = WebType.ImageBoard;break;
					case "file":
						type = WebType.FileBoard;break;
					case "wiki":
						type = WebType.Wiki;break;
					case "blog":
						type = WebType.Blog;break;
				}
				if(param["title"]!=null&&param["title"].Length > 4 && Array.IndexOf(WebCategories.Categories,param["category"])>=0)
				{
					Guid pageID;
					Interface.CreatePage(param["title"],param["category"],(int)type,param["certi"],out pageID);
					
					return HttpServerSetting.HtmlEncoding.GetBytes(HtmlGenerators.TemplateFieldReplacer.ReplaceGatewayFields(HttpHtmlGenerator.ReadTemplateFile("template\\gateway\\created.html"),WebCacheReader.ReadHeader(pageID),"",0));
				}
				else
					return System.Text.Encoding.UTF8.GetBytes(HttpHtmlGenerator.ReadTemplateFile("template\\gateway\\unauthorized.html"));
			}
			else
			{
				return System.Text.Encoding.UTF8.GetBytes(HttpHtmlGenerator.ReadTemplateFile("template\\gateway\\unauthorized.html"));
			}
		}
	}
}
