using System;

namespace RinGOch
{
	public class WebHeaderComparer : System.Collections.IComparer
	{
		WebHeaderComparerField _field;
		int _flag;
		public WebHeaderComparer(WebHeaderComparerField field,bool flag)
		{
			_field = field;
			if(flag)
				_flag = -1;
			else
				_flag = 1;
		}
		#region IComparer o

		public int Compare(object x, object y)
		{
			try
			{
				WebHeaderInfo xx = (WebHeaderInfo)x;
				WebHeaderInfo yy = (WebHeaderInfo)y;

				switch(_field)
				{
					case WebHeaderComparerField.Category:
						return xx.Category.CompareTo(yy.Category) * _flag;
					case WebHeaderComparerField.Guid:
						return xx.GUID.CompareTo(yy.GUID) * _flag;
					case WebHeaderComparerField.MgrUpdate:
						return xx.Created.CompareTo(yy.Created) * _flag;
					case WebHeaderComparerField.Posts:
						return xx.Posts.CompareTo(yy.Posts) * _flag;
					case WebHeaderComparerField.Size:
						return xx.Size.CompareTo(yy.Size) * _flag;
					case WebHeaderComparerField.Title:
						return xx.Title.CompareTo(yy.Title) * _flag;
					case WebHeaderComparerField.Type:
						return WebTypeToString.ToString(xx.Type).CompareTo(WebTypeToString.ToString(yy.Type)) * _flag;
					case WebHeaderComparerField.Update:
						return xx.Update.CompareTo(yy.Update) * _flag;
					default:
						return 0;
				}
			}
			catch
			{
				return 0;
			}
		}

		#endregion
	}

	public enum WebHeaderComparerField
	{
		Title,
		Size,
		Posts,
		Update,
		MgrUpdate,
		Type,
		Category,
		Guid
	}
}
