using System;
using System.Collections;
using System.Text;
using RinGOch.HtmlGenerators;
using RinGOch.WikiEngine;

namespace RinGOch.WikiEngine
{
	/// <summary>
	/// [[#comment(id)]]u܂
	/// </summary>
	public class CommentTransformer
	{
		public static string Transform(string id,string snum,WebHeaderInfo header,WebPostInfo disp,WebPostInfo[] posts)
		{
			StringBuilder html = new StringBuilder();
			
			int num = 0;
			if(TextUtility.IsNumeric(snum))
				num = int.Parse(snum);
			if(num <= 0)
				num = int.MaxValue;

			// ev[gǂݍ
			string _header = HttpHtmlGenerator.ReadTemplateFile("template\\wiki\\wiki_comment_header.html");
			string _res = HttpHtmlGenerator.ReadTemplateFile("template\\wiki\\wiki_comment_res.html");
			string _footer = HttpHtmlGenerator.ReadTemplateFile("template\\wiki\\wiki_comment_footer.html");

			// id̃X𒊏o
			ArrayList comments = new ArrayList();

			// \ȏ̏ꍇ̓ACe폜ĕ\܂Ō炷
			foreach(WebPostInfo post in posts)
				if(post.FileName == "\0" + id)
					comments.Add(post);
			
			// eŕבւ
			comments.Sort(new WebPostInfoComparer());
			while(comments.Count > num)
				comments.RemoveAt(0);

			// wb_uĒǉ
			html.Append(TemplateFieldReplacer.ReplaceCommonPostFields(TemplateFieldReplacer.ReplaceCommonHeaderFields(TemplateFieldReplacer.ReplaceField(_header,"%_wiki_comment_id%",id),header),disp));

			// Rgǉ
			InlineReplacer replacer = new InlineReplacer("",header,posts,disp);
			replacer.enableEmbedded = false;
			foreach(WebPostInfo post in comments)
			{
				WebPostInfo temp = new WebPostInfo(post.Name,replacer.ReplaceInline(new LineData.EmptyLineData(ContentsTransformer.ReplaceSpecialChars(post.Body)),InlineReplacer.ReplaceType.Contents),post.Posted,post.GUID,post.Trip,post.Signature,post.FileName,post.Data);
				//WebPostInfo temp = new WebPostInfo(post.Name,Engine.Transform(post.Body,header,posts,post),post.Posted,post.GUID,post.Trip,post.Signature,post.FileName,post.Data);
				//html.Append(TemplateFieldReplacer.ReplaceCommonPostFields(_res,temp));
				//html.Append(replacer.ReplaceInline(new LineData.EmptyLineData(TemplateFieldReplacer.ReplaceCommonPostFields(_res,post)),InlineReplacer.ReplaceType.Contents));
				html.Append(TemplateFieldReplacer.ReplaceCommonPostFields(_res,temp));
			}

			// tb^uĒǉ
			html.Append(TemplateFieldReplacer.ReplaceCommonPostFields(TemplateFieldReplacer.ReplaceCommonHeaderFields(TemplateFieldReplacer.ReplaceField(_footer,"%_wiki_comment_id%",id),header),disp));

			return html.ToString();
		}
	}
}
