using System;

namespace RinGOch.WikiEngine.LineData.Chains
{
	public class LineDataFactory
	{
		private LineChain chain;

		public LineDataFactory()
		{
			SetChain();
		}

		/// <summary>
		/// Ώۍsf[^𐶐`F[ݒ肵܂B
		/// </summary>
		/// <param name="isShowHeading">oXg\邩ǂ</param>
		private void SetChain()
		{
			chain = new EmptyLineChain();

			LineChain next = chain.SetNext(new HorizonLineChain());
			next = next.SetNext(new HeadingLineChain());
			next = next.SetNext(new UnorderedListLineChain());
			next = next.SetNext(new OrderedListLineChain());
			next = next.SetNext(new BlockquoteLineChain());
			next = next.SetNext(new DifinitionListLineChain());
			next = next.SetNext(new TableLineChain());
			next = next.SetNext(new PreformatLineChain());
			next = next.SetNext(new ArrangedLineChain());
		}

		/// <summary>
		/// sf[^𐶐܂B
		/// </summary>
		/// <param name="line">s</param>
		/// <returns>sf[^</returns>
		/// <remarks>
		/// w肳ꂽsgp
		/// <see cref="NWiki.Core.Transform.LineData.ILineData">ILineData</see>
		/// ̎NX̃CX^X𐶐܂B
		/// </remarks>
		public ILineData Create(string line)
		{
			return chain.CreateFrom(line);
		}
	}
}
