using System;
using System.Text.RegularExpressions;

namespace RinGOch.WikiEngine.LineData.Chains
{
	public class OrderedListLineChain : LineChain
	{
		public OrderedListLineChain()
		{}

		protected override ILineData CreateLineData(string line)
		{
			Match match = Regex.Match(line, @"^(?<keyword>\+{1,3})(?<content>.*)");

			if (match.Success)
				return new OrderedListLineData(match.Groups["keyword"].Value, match.Groups["content"].Value);
			else
				return null;
		}
	}
}
