using System;
using System.Text.RegularExpressions;

namespace RinGOch.WikiEngine.LineData.Chains
{
	public class PreformatLineChain : LineChain
	{
		public PreformatLineChain()
		{}

		protected override ILineData CreateLineData(string line)
		{
			Match match = Regex.Match(line, @"^(?<keyword>\s)(?<content>.*)");

			if (match.Success)
				return new PreformatLineData(match.Groups["keyword"].Value, match.Groups["content"].Value);
			else
				return null;
		}
	}
}
