using System;

namespace RinGOch.WikiEngine.LineData
{
	/// <summary>
	/// h^Oɑ΂L[[h [***], [**], [*] ܂ލs\NXłB
	/// </summary>
	public class HeadingLineData : ILineData
	{
		private const string TAG_H = "h";

		private string _keyword;
		private string _content;
		private string _tag;
		
		/// <summary>
		/// RXgN^łB
		/// </summary>
		/// <param name="keyword">L[[h</param>
		/// <param name="content">e</param>
		public HeadingLineData(string keyword, string content)
		{
			_keyword = keyword;
			_content = content;
			_tag = TAG_H + (keyword.Length + 1).ToString();
		}
		
		#region ILineData C^[tFCX̎
		
		public string Keyword
		{
			get { return _keyword; }
		}

		public string GetOpenTag(ILineData previous)
		{
			return "<" + _tag + ">";
		}

		public string GetCloseTag(ILineData next)
		{
			return "</" + _tag + ">\r\n";
		}
		
		/// <summary>
		/// 擾܂B
		/// </summary>
		/// <returns></returns>
		/// <remarks>
		/// IDւ̃N܂ލ擾܂B
		/// </remarks>
		public string GetHeading()
		{
			return "";
			/*if (isShowHeading)
			{
				StringBuilder builder = new StringBuilder();
				builder.Append(new string('-', keyword.Length));
				builder.Append("<a href=\"#heading:");
				builder.Append(headingId.ToString());
				builder.Append("\">");
				builder.Append(content);
				builder.Append("</a>\r\n");

				return builder.ToString();
			}
			else
				return string.Empty;*/
		}


		public string GetContent()
		{
			/*if (isShowHeading)
			{
				StringBuilder builder = new StringBuilder();
				builder.Append("<a name=\"heading:");
				builder.Append(headingId.ToString());
				builder.Append("\"></a>");
				builder.Append(content);
				builder.Append(" <a href=\"#heading:0\">^</a>");

				return builder.ToString();
			}
			else
				return content;*/
			return _content;
		}

		#endregion
	}
}
