using System;
using System.Text;

namespace RinGOch.WikiEngine.LineData
{
	/// <summary>
	/// Kwꂽ^Oɑ΂L[[h܂ލs\钊ۃNXłB
	/// </summary>
	public abstract class HierarchicalLineData : ILineData
	{
		private enum OpenType { Open = 0, Close = 1 }

		protected string _keyword;
		protected string _content;
		private string	 _tag;

		/// <summary>
		/// RXgN^łB
		/// </summary>
		/// <param name="keyword">L[[h</param>
		/// <param name="content">e</param>
		/// <param name="holdTag">e^O</param>
		public HierarchicalLineData(string keyword, string content, string tag)
		{
			_keyword = keyword;
			_content = content;
			_tag = tag;
		}

		#region ILineData C^[tFCX̎
		
		public string Keyword
		{
			get { return _keyword; }
		}

		public string GetOpenTag(ILineData previous)
		{
			if (previous.GetType().Equals(this.GetType()))
				return GetTagFromDepth(OpenType.Open, _keyword.Length - previous.Keyword.Length);
			else
				return GetTagFromDepth(OpenType.Open, _keyword.Length);
		}
		
		public string GetCloseTag(ILineData next)
		{
			if (next.GetType().Equals(this.GetType()))
				return GetTagFromDepth(OpenType.Close, _keyword.Length - next.Keyword.Length);
			else
				return GetTagFromDepth(OpenType.Close, _keyword.Length);
		}

		/// <summary>
		/// Kwɉ^O擾܂B
		/// </summary>
		/// <param name="openType">^O̎</param>
		/// <param name="depth">Kw̐[</param>
		/// <returns>Kwɉ^O</returns>
		private string GetTagFromDepth(OpenType openType, int depth)
		{
			StringBuilder builder = new StringBuilder();

			for (int i = 0; i < depth; i++)
				builder.Append(GetTag(openType));
			
			return builder.ToString();
		}
		
		/// <summary>
		/// ^O擾܂B
		/// </summary>
		/// <param name="openType">^O̎</param>
		/// <returns>^O</returns>
		private string GetTag(OpenType openType)
		{
			if (openType == OpenType.Open)
				return "<" + _tag + ">\r\n";
			else
				return "</" + _tag + ">\r\n";
		}

		public string GetHeading()
		{
			return "";
		}

		public abstract string GetContent();
		
		#endregion
	}
}
